/* -*- tab-width: 4 -*- */

#include "elkkernel.h"

ELKObject V_Autoload_Notifyp;

void Init_Auto () {
	Define_Variable (&V_Autoload_Notifyp, x_("autoload-notify?"), Trueob);
}

ELKObject P_Autoload (ELKObject sym, ELKObject files) {
	ELKObject al, ret;
	GC_Node3;

	al = Null;
	Check_Type (sym, T_Symbol);
	Check_Loadarg (files);
	GC_Link3 (al, sym, files);
	al = Alloc_Object (sizeof (struct S_Autoload), T_Autoload, 0);
	AUTOLOAD(al)->files = files;
	AUTOLOAD(al)->env = The_Environment;
	al = Cons (al, Null);
	al = Cons (sym, al);
	ret = P_Define (al);
	GC_Unlink;
	return ret;
}

ELKObject Do_Autoload (ELKObject sym, ELKObject al) {
	ELKObject val, a[1];
	GC_Node;

	if (Var_Is_True (V_Autoload_Notifyp)) {
		a[0] = AUTOLOAD(al)->files;
		Format (Standard_Output_Port, x_("[Autoloading ~a]~%"), 18, 1, a);
	}
	GC_Link (sym);
	(void)General_Load (AUTOLOAD(al)->files, AUTOLOAD(al)->env);
	GC_Unlink;
	val = SYMBOL(sym)->value;
	if (TYPE(val) == T_Autoload)
		Primitive_Error (x_("autoloading failed to define ~s"), sym);
	return val;
}
