/* -*- tab-width: 4 -*-
 *
 *     ********************************************************************* 
 *     * Copyright (C) 1988, 1990 Stanford University.                     * 
 *     * Permission to use, copy, modify, and distribute this              * 
 *     * software and its documentation for any purpose and without        * 
 *     * fee is hereby granted, provided that the above copyright          * 
 *     * notice appear in all copies.  Stanford University                 * 
 *     * makes no representations about the suitability of this            * 
 *     * software for any purpose.  It is provided "as is" without         * 
 *     * express or implied warranty.                                      * 
 *     ********************************************************************* 
 */

#ifdef USER_SUBCKT 
#ifndef LOW
typedef CHAR  *uptr;
typedef uptr (*ufun)();

#define LOW             0       /* low low */
#define X               1       /* unknown, intermediate, ... value */
#define X_X             2
#define HIGH            3       /* logic high */
#define N_POTS          4       /* number of potentials [LOW-HIGH] */
#define d2ns(D)         ((D) * 0.01) 
#define d2ps(D)         ((D) * 10.0)

#endif


typedef struct 
{
    CHAR	*name;			/* name of this sub-circuit */
    ufun	model;			/* function that models sub-circuit */
    ufun	init;			/* Function to call to init */
} userSubCircuit;

#endif



